# Class DiscreteFilesClassLoader

java.lang.Object
java.lang.ClassLoader
java.security.SecureClassLoader
java.net.URLClassLoader
bsh.classpath.BshClassLoader
bsh.classpath.DiscreteFilesClassLoader

All Implemented Interfaces:
  `Closeable, AutoCloseable`

public class DiscreteFilesClassLoader extends BshClassLoader
A classloader which can load one or more classes from specified sources. Because the classes are loaded via a single classloader they change as a group and any versioning cross dependencies can be managed.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`DiscreteFilesClassLoader.ClassSourceMap`

## Constructor Summary

Constructors
Constructor
Description
`DiscreteFilesClassLoader(BshClassManager classManager, DiscreteFilesClassLoader.ClassSourceMap map)`

## Method Summary

Modifier and Type
Method
Description
`Class`
`findClass(String name)`
Find the correct source for the class...
`String`
`toString()`

### Methods inherited from class BshClassLoader

`addURL, loadClass`

### Methods inherited from class URLClassLoader

`close, definePackage, findResource, findResources, getPermissions, getResourceAsStream, getURLs, newInstance, newInstance`

### Methods inherited from class SecureClassLoader

`defineClass, defineClass`

### Methods inherited from class ClassLoader

`clearAssertionStatus, defineClass, defineClass, defineClass, defineClass, definePackage, findClass, findLibrary, findLoadedClass, findResource, findSystemClass, getClassLoadingLock, getDefinedPackage, getDefinedPackages, getName, getPackage, getPackages, getParent, getPlatformClassLoader, getResource, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, getUnnamedModule, isRegisteredAsParallelCapable, loadClass, registerAsParallelCapable, resolveClass, resources, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, setSigners`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### DiscreteFilesClassLoader

public DiscreteFilesClassLoader(BshClassManager classManager, DiscreteFilesClassLoader.ClassSourceMap map)

## Method Details

### findClass

public Class findClass(String name) throws ClassNotFoundException
Description copied from class: `BshClassLoader`
Find the correct source for the class... Try designated loader if any Try our URLClassLoader paths if any Try base loader if any Try system ???

Overrides:
  `findClass` in class `BshClassLoader`
Throws:
  `ClassNotFoundException`

### toString

public String toString()

Overrides:
  `toString` in class `Object`